/*
 * $Id: Vector.as,v 1.1.1.1 2007/04/01 08:25:41 kenta Exp $
 *
 * Copyright 2006 Kenta Cho. Some rights reserved.
 */
package abagames.util {
  
  /**
   * 2D Vector.
   */
  public class Vector {
    public var x:Number = 0;
    public var y:Number = 0;

    public function Vector(x:Number = 0, y:Number = 0) {
      this.x = x;
      this.y = y;
    }

    public function mul(v:Number):void {
      x *= v;
      y *= v;
    }

    public function dist(p:Vector):Number {
      var ox:Number = Math.abs(p.x - x);
      var oy:Number = Math.abs(p.y - y);
      if (ox > oy)
        return ox + oy / 2;
      else
        return oy + ox / 2;
    }
  }
}
